/**//*   配置   */
#include "keybinding.h"
static gvoid close_config_dialog(GtkWidget *widget ) {
    show_config_dialog = FALSE;
    save_config();
    gtk_widget_destroy(config_dialog);
    show_iceplayer = FALSE;
}
static gboolean on_fontbutton_font_set(GtkFontButton   *fontbutton,gint  type) {
    PangoFontDescription *pfd;
    pfd = pango_font_description_from_string(gtk_font_button_get_font_name(fontbutton));
    switch (type) {
    case 1: {
        strcpy(font_treeview,gtk_font_button_get_font_name(fontbutton));
        gtk_widget_modify_font(GTK_WIDGET(treeview),pfd);
        break;
    }
    case 2: {
        strcpy(font_info1,gtk_font_button_get_font_name(fontbutton));
        gtk_widget_modify_font(GTK_WIDGET(label_info),pfd);
        break;
    }
    case 3: {
        strcpy(font_info2,gtk_font_button_get_font_name(fontbutton));
        gtk_widget_modify_font(GTK_WIDGET(label_info2),pfd);
        break;
    }
    case 4 : {
        strcpy(font_info3,gtk_font_button_get_font_name(fontbutton));
        gtk_widget_modify_font(GTK_WIDGET(label_info3),pfd);
        break;
    }
    case 5 : {
        strcpy(font_lrc,gtk_font_button_get_font_name(fontbutton));
        if (lrc_label)gtk_widget_modify_font(GTK_WIDGET(lrc_label),pfd);
        if (lrc_label)gtk_widget_modify_font(GTK_WIDGET(lrc_label2),pfd);
        if (GTK_IS_WINDOW(lrc_window))  gtk_window_resize((GtkWindow   *)lrc_window,1,1);
        if (config_label1)gtk_widget_modify_font (config_label1, pfd);
        if (config_label8)gtk_widget_modify_font (config_label8, pfd);
        break;
    }
    }
    pango_font_description_free(pfd);
    return FALSE;
}
static gvoid on_checkbutton_toggled(GtkToggleButton *togglebutton,gint type) {
    switch (type) {
    case 2: {
        if (gtk_toggle_button_get_active       ( (GtkToggleButton *)checkbutton_save_volume)) {
            save_volume=TRUE;
        } else {
            save_volume=FALSE;
        }
        break;
    }
    case 3: {
        if (gtk_toggle_button_get_active       ( (GtkToggleButton *)checkbutton_show_tools)) {
            gtk_widget_set_size_request(fixed_list,300,30);
            gtk_widget_show(eventbox_tools_add);
            gtk_widget_show(eventbox_tools_dele);
            gtk_widget_show(eventbox_tools_list);
            gtk_widget_show(eventbox_tools_mode);
            show_tools=TRUE;
        } else {
            gtk_widget_set_size_request(fixed_list,300,11);
            gtk_widget_hide(eventbox_tools_add);
            gtk_widget_hide(eventbox_tools_dele);
            gtk_widget_hide(eventbox_tools_list);
            gtk_widget_hide(eventbox_tools_mode);
            show_tools=FALSE;
        }
        break;
    }
    case 4: {
        if (gtk_toggle_button_get_active       ( (GtkToggleButton *)checkbutton_save_file)) {
            save_file=TRUE;
        } else {
            save_file=FALSE;
        }
        break;
    }
    case  5: {
        if (gtk_toggle_button_get_active       ( (GtkToggleButton *)checkbutton_save_pos_size)) {
            save_pos_size=TRUE;
        } else {
            save_pos_size=FALSE;
        }
        break;
    }
    case  6: {
        if (gtk_toggle_button_get_active       ( (GtkToggleButton *)checkbutton_save_file_playing)) {
            save_file_playing=TRUE;
        } else {
            save_file_playing=FALSE;
        }
        break;
    }
    case 7: {
        if (gtk_toggle_button_get_active       ( (GtkToggleButton *)checkbutton_save_if_play)) {
            save_if_play=TRUE;
        } else {
            save_if_play = FALSE;
        }
        break;
    }
    case 8: {
        if (gtk_toggle_button_get_active       ( (GtkToggleButton *)checkbutton_save_play_mode)) {
            save_play_mode=TRUE;
        } else {
            save_play_mode = FALSE;
        }
        break;
    }
    case 9: {
        if (gtk_toggle_button_get_active       ( (GtkToggleButton *)checkbutton_show_notify)) {
            show_notify=TRUE;
        } else {
            show_notify = FALSE;
        }
        break;
    }
    case 10: {
        if (gtk_toggle_button_get_active       ( (GtkToggleButton *)checkbutton_show_min)) {
            show_min=TRUE;
        } else {
            show_min = FALSE;
        }
        break;
    }
    case 11: {
        if (gtk_toggle_button_get_active       ( (GtkToggleButton *)checkbutton_show_lrc)) {
            show_lrc=TRUE;
        } else {
            show_lrc = FALSE;
            save_download_lrc = FALSE;
            gtk_toggle_button_set_active       ( (GtkToggleButton *)checkbutton_save_download_lrc,FALSE);
        }
        close_lrc();
        break;
    }
    case 12: {
        if (gtk_toggle_button_get_active       ( (GtkToggleButton *)checkbutton_save_lrc_no_has_press_event)) {
            save_lrc_no_has_press_event=TRUE;
        } else {
            save_lrc_no_has_press_event = FALSE;
        }
        close_lrc();
        if (show_lrc)lrc_show("09");//不要怀疑,是的，他就是09,不要疑惑，是的，他还是09. 为什么不是10?  2010多好啊，～_～要求那么高，自己改去。
        break;
    }
    case 13: {
        if (gtk_toggle_button_get_active       ( (GtkToggleButton *)checkbutton_save_download_lrc)) {
            save_download_lrc=TRUE;
        } else {
            save_download_lrc = FALSE;
        }
        break;
    }
    case 14: {
        if (gtk_toggle_button_get_active       ( (GtkToggleButton *)checkbutton_save_download_lrc_path)) {
            save_download_lrc_path=TRUE;
            gtk_widget_set_sensitive (config_entry_download_lrc_path,FALSE);
            gtk_button_set_label(&(((GtkToggleButton *)checkbutton_save_download_lrc_path)->button),"当前状态:下载歌词到歌曲所在目录");

        } else {
            save_download_lrc_path = FALSE;
            gtk_widget_set_sensitive (config_entry_download_lrc_path,TRUE);
            gtk_button_set_label(&(((GtkToggleButton *)checkbutton_save_download_lrc_path)->button),"当前状态:下载歌词到指定目录");
        }
        break;
    }
    case 15: {
        if (gtk_toggle_button_get_active       ( (GtkToggleButton *)checkbutton_save_desktop_lrc_back_png)) {
            save_desktop_lrc_back_png=TRUE;
            gtk_widget_set_sensitive (config_entry_desktop_lrc_back_png,TRUE);
        } else {
            save_desktop_lrc_back_png = FALSE;
            gtk_widget_set_sensitive (config_entry_desktop_lrc_back_png,FALSE);
        }
        close_lrc();
        if (show_lrc)lrc_show("09");
        break;
    }
    }
}
static gvoid on_reset_button_clicked(GtkWidget *widget,gpointer user_data) {
    GtkWidget *dialog_real = gtk_message_dialog_new(NULL,0, GTK_MESSAGE_QUESTION,GTK_BUTTONS_OK_CANCEL,"是否确认将所有设置返回默认？");
    if (gtk_dialog_run((GtkDialog *) dialog_real) !=-5) {
        gtk_widget_destroy(dialog_real);
        return ;
    }
    gtk_widget_destroy(dialog_real);
    gtk_font_button_set_font_name((GtkFontButton   *)fontbutton_treeview,"sans 8");
    gtk_font_button_set_font_name((GtkFontButton   *)fontbutton_info1,"sans 9");
    gtk_font_button_set_font_name((GtkFontButton   *)fontbutton_info2,"sans 8");
    gtk_font_button_set_font_name((GtkFontButton   *)fontbutton_info3,"sans 7");
    gtk_font_button_set_font_name((GtkFontButton   *)fontbutton_lrc,"sans 32");
    on_fontbutton_font_set ((GtkFontButton   *)fontbutton_treeview,1);
    on_fontbutton_font_set ((GtkFontButton   *)fontbutton_info1,2);
    on_fontbutton_font_set ((GtkFontButton   *)fontbutton_info2,3);
    on_fontbutton_font_set ((GtkFontButton   *)fontbutton_info3,4);
    on_fontbutton_font_set ((GtkFontButton   *)fontbutton_lrc,5);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_pos_size), TRUE);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_file), TRUE);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_show_tools), TRUE);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_volume), TRUE);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_file_playing),TRUE);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_if_play),FALSE);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_play_mode), TRUE);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_show_notify),TRUE);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_show_min),TRUE);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_show_lrc),TRUE);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_lrc_no_has_press_event),FALSE);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_download_lrc),TRUE);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_download_lrc_path),TRUE);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_desktop_lrc_back_png),FALSE);
    unlink(config_file_path);
    FILE * fileconfig = fopen(config_file_path,"a+");
    fputs("#此文件为IcePlayer的配置文件，几个变量顺序不变就行,“#”开头的将忽略，空行值为0\n#是否保存播放列表，1为保存，0为不保存。\n1\n#是否保存窗口大小位置，1为保存，0为不保存。\n1\n#大小位置(width,height,x,y)\n300,480,538,172\n#是否保存正在播放的歌曲，1为保存，0为不保存。\n0\n#是否保存播放状态，1为保存，0为不保存。\n0\n#是否显示工具条，1为显示，0为不显示。\n1\n#是否保存音量，1为保存，0为不保存。\n1\n#音量\n100\n#列表框的字体和大小\nsans 8\n#“正在播放“文本框的字体和大小\nsans 9\n#“播放状态“\nsans 8\n#”播放时间“\nsans 7\n#歌词字体\nsans 32\n#是否保存选中的歌曲以便下次打开时选中？1为保存，0为不保存.\n1\n播放歌曲的序号，0为第一首\n0\n#是否打开就播放？1是，0否。\n0\n#记录播放模式？1为保存，0为不保存\n1\n#播放模式 0为顺序 1为随机 2为单曲\n1\n#显示notify? 1为显示 0为不显示\n1\n#自动缩进？1 是 0 否\n1\n#使用歌词？1 是 0否。\n1\n#歌词鼠标穿透？1 是 0否\n0\n0,0\n#歌词主颜色\nB19356\n#歌词次颜色\n000000\n#是否使用歌词下载功能?1 是 0否。\n1\n#是否将歌词下载于歌曲目录?1是 或 指定目录。\n1\n#是否使用桌面歌词背景？0否或指定png(如 /home/slax/图片/1.png )\n0\n# jasy.ice@163.com 2010 GPL\n ",fileconfig);
    fclose(fileconfig);
    strcpy(lrc_color_front,"B19356");
    strcpy(lrc_color_back,"000000");

    gtk_label_set_markup ((GtkLabel  *)config_label1, g_markup_printf_escaped ("<span  foreground='#%s'>歌词</span>",lrc_color_back));
    gtk_label_set_markup ((GtkLabel  *)config_label8, g_markup_printf_escaped ("<span  foreground='#%s'>歌词</span>",lrc_color_front));

    gtk_label_set_markup ((GtkLabel  *)GTK_BIN (config_button_color_front)->child, g_markup_printf_escaped ("主颜色<span  foreground='#%s'> ███</span>",lrc_color_front));
    gtk_label_set_markup ((GtkLabel  *)GTK_BIN (config_button_color_back)->child, g_markup_printf_escaped ("次颜色<span  foreground='#%s'> ███</span>",lrc_color_back));
    lrc_x = 0;
    lrc_y= 0;
}
static gvoid set_color(GtkButton       *button,gint type) {
    if (type == 0) {
        gtk_widget_destroy(colorselectiondialog);
        return ;
    }

    gdouble color[3];
    GdkColor gdk_color;
    gchar x_color[200];
    gchar x_color_red[200];
    gchar x_color_green[200];
    gchar x_color_blue[200];

    gtk_color_selection_get_color ( (GtkColorSelection*)gtk_color_selection_dialog_get_color_selection(  (GtkColorSelectionDialog *)colorselectiondialog),color);
    if (type==1||type-100 ==1) {
        lrc_front_color_double[0]=color[0];
        lrc_front_color_double[1]=color[1];
        lrc_front_color_double[2]=color[2];
    }
    if (type==2||type-100 ==2) {
        lrc_back_color_double[0]=color[0];
        lrc_back_color_double[1]=color[1];
        lrc_back_color_double[2]=color[2];
    }
    gdk_color.red = (guint16)(color[0]*255.0);
    gdk_color.green = (guint16)(color[1]*255.0);
    gdk_color.blue = (guint16)(color[2]*255.0);

    g_snprintf(x_color_red,30,"%x",gdk_color.red);
    g_snprintf(x_color_green,30,"%x",gdk_color.green);
    g_snprintf(x_color_blue,30,"%x",gdk_color.blue);

    if (!x_color_red[1])
        x_color_red[1]='0';
    x_color_red[2]=0;
    if (!x_color_green[1])
        x_color_green[1]='0';
    x_color_green[2]=0;
    if (!x_color_blue[1])
        x_color_blue[1]='0';
    x_color_blue[2]=0;

    strcpy(x_color,x_color_red);
    strcat(x_color,x_color_green);
    strcat(x_color,x_color_blue);

    if (type-10==1||type-100 ==1) {
        strcpy(lrc_color_front,x_color);
    }

    if (type-10==2||type-100 ==2) {
        strcpy(lrc_color_back,x_color);
    }

    lrc_show("09");
    if (GTK_IS_WIDGET(config_button_color_front)) gtk_label_set_markup ((GtkLabel  *)GTK_BIN (config_button_color_front)->child, g_markup_printf_escaped ("主颜色<span  foreground='#%s'> ███</span>",lrc_color_front));
    if (GTK_IS_WIDGET(config_button_color_back))gtk_label_set_markup ((GtkLabel  *)GTK_BIN (config_button_color_back)->child, g_markup_printf_escaped ("次颜色<span  foreground='#%s'> ███</span>",lrc_color_back));

    if (GTK_IS_WIDGET(config_label1))gtk_label_set_markup ((GtkLabel  *)config_label1, g_markup_printf_escaped ("<span  foreground='#%s'>歌词</span>",lrc_color_back));
    if (GTK_IS_WIDGET(config_label8))gtk_label_set_markup ((GtkLabel  *)config_label8, g_markup_printf_escaped ("<span  foreground='#%s'>歌词</span>",lrc_color_front));

    PangoFontDescription *font_desc = pango_font_description_from_string(font_lrc);
    if (GTK_IS_WIDGET(config_label1)) gtk_widget_modify_font (config_label1, font_desc);
    if (GTK_IS_WIDGET(config_label8)) gtk_widget_modify_font (config_label8, font_desc);
    pango_font_description_free (font_desc);

    if (type > 100) {
        gtk_widget_destroy(colorselectiondialog);
        return ;
    }
}
static gvoid get_colorselection(gpointer data , gint type) {
    GtkWidget *ok_button;
    GtkWidget *cancel_button;
    GtkWidget *help_button;
    GtkWidget *color_selection;

    colorselectiondialog = gtk_color_selection_dialog_new ("选择颜色");
    gtk_container_set_border_width (GTK_CONTAINER (colorselectiondialog), 5);
    gtk_window_set_modal (GTK_WINDOW (colorselectiondialog), FALSE);
    gtk_window_set_resizable (GTK_WINDOW (colorselectiondialog), FALSE);

    ok_button = GTK_COLOR_SELECTION_DIALOG (colorselectiondialog)->ok_button;
    gtk_widget_show (ok_button);
    gtk_button_set_label ((GtkButton      *)ok_button,"确定");
    gtk_button_set_image((GtkButton      *)ok_button,gtk_image_new_from_stock("gtk-yes",GTK_ICON_SIZE_BUTTON));
    GTK_WIDGET_SET_FLAGS (ok_button, GTK_CAN_DEFAULT);
    gtk_button_set_relief (GTK_BUTTON (ok_button), GTK_RELIEF_NONE);

    cancel_button = GTK_COLOR_SELECTION_DIALOG (colorselectiondialog)->cancel_button;
    gtk_widget_show (cancel_button);
    gtk_button_set_label ((GtkButton      *)cancel_button,"取消");
    gtk_button_set_image((GtkButton      *)cancel_button,gtk_image_new_from_stock("gtk-no",GTK_ICON_SIZE_BUTTON));
    GTK_WIDGET_SET_FLAGS (cancel_button, GTK_CAN_DEFAULT);
    gtk_button_set_relief (GTK_BUTTON (cancel_button), GTK_RELIEF_NONE);

    help_button = GTK_COLOR_SELECTION_DIALOG (colorselectiondialog)->help_button;
    gtk_widget_show (help_button);
    gtk_button_set_label ((GtkButton      *)help_button,"应用");
    gtk_button_set_image((GtkButton      *)help_button,gtk_image_new_from_stock("gtk-yes",GTK_ICON_SIZE_BUTTON));
    GTK_WIDGET_SET_FLAGS (help_button, GTK_CAN_DEFAULT);
    gtk_button_set_relief (GTK_BUTTON (help_button), GTK_RELIEF_NONE);

    color_selection = GTK_COLOR_SELECTION_DIALOG (colorselectiondialog)->colorsel;
    gtk_widget_show (color_selection);
    gtk_container_set_border_width (GTK_CONTAINER (color_selection), 5);
    gtk_color_selection_set_has_opacity_control (GTK_COLOR_SELECTION (color_selection), FALSE);
    gtk_color_selection_set_has_palette (GTK_COLOR_SELECTION (color_selection), TRUE);

    int color[3];
    if (type ==1) {
        sscanf(lrc_color_front,"%02x%02x%02x",&color[0],&color[1],&color[2]);
        lrc_front_color_double[0] =( (double)color[0])/255.0;
        lrc_front_color_double[1] =( (double) color[1])/255.0;
        lrc_front_color_double[2] = ((double)color[2])/255.0;
        gtk_color_selection_set_color( (GtkColorSelection *)color_selection,lrc_front_color_double);
    }
    if (type ==2) {
        sscanf(lrc_color_back,"%02x%02x%02x",&color[0],&color[1],&color[2]);
        lrc_back_color_double[0] =( (double)color[0])/255.0;
        lrc_back_color_double[1] =( (double) color[1])/255.0;
        lrc_back_color_double[2] = ((double)color[2])/255.0;
        gtk_color_selection_set_color((GtkColorSelection *)color_selection,lrc_back_color_double);
    }

    g_signal_connect((gpointer) help_button ,"clicked" ,G_CALLBACK(set_color),(gpointer )type+10);
    g_signal_connect((gpointer) ok_button ,"clicked" ,G_CALLBACK(set_color),(gpointer )(type+100));
    g_signal_connect((gpointer) cancel_button ,"clicked" ,G_CALLBACK(set_color),(gpointer )0);

    gtk_dialog_run((GtkDialog *)colorselectiondialog);
}
gvoid Config() {
    if (!show_config_dialog) {
        config_dialog = gtk_window_new (GTK_WINDOW_TOPLEVEL);
        gtk_widget_set_size_request (config_dialog,500, 370);
        gtk_window_set_title (GTK_WINDOW (config_dialog), "配置IcePlayer");
        gtk_window_set_resizable (GTK_WINDOW (config_dialog), FALSE);

        GdkPixbuf *IcePlayer_icon_pixbuf=gdk_pixbuf_new_from_inline  (-1,pix_iceplayer,TRUE,NULL);
        gtk_window_set_icon(GTK_WINDOW(config_dialog),IcePlayer_icon_pixbuf);
        gtk_window_set_position (GTK_WINDOW (config_dialog), GTK_WIN_POS_CENTER);
        gtk_window_set_keep_above     (GTK_WINDOW (config_dialog),TRUE);

        fixed = gtk_fixed_new ();
        gtk_widget_show (fixed);
        gtk_container_add (GTK_CONTAINER (config_dialog), fixed);

        gint aa = 8;
        gint bb = 0;
        gint cc = 35;

        config_label2 = gtk_label_new ("列表框字体：");
        gtk_widget_show (config_label2);
        gtk_fixed_put (GTK_FIXED (fixed), config_label2, 196, aa+cc*(bb++));
        gtk_widget_set_size_request (config_label2, 148, 24);

        config_label3 = gtk_label_new ("\"正在播放\"字体：");
        gtk_widget_show (config_label3);
        gtk_fixed_put (GTK_FIXED (fixed), config_label3, 196, aa+cc*(bb++));
        gtk_widget_set_size_request (config_label3, 148, 24);

        config_label4 = gtk_label_new ("\"播放状态\"字体：");
        gtk_widget_show (config_label4);
        gtk_fixed_put (GTK_FIXED (fixed), config_label4, 196, aa+cc*(bb++));
        gtk_widget_set_size_request (config_label4, 148, 24);

        config_label5 = gtk_label_new ("\"播放时间\"字体：");
        gtk_widget_show (config_label5);
        gtk_fixed_put (GTK_FIXED (fixed), config_label5, 196, aa+cc*(bb++));
        gtk_widget_set_size_request (config_label5, 148, 24);

        config_label1 = gtk_label_new ("歌词");
        gtk_widget_show (config_label1);
        gtk_fixed_put (GTK_FIXED (fixed), config_label1, 335, 177);
        gtk_widget_set_size_request (config_label1, 148, 72);

        config_label8 = gtk_label_new ("歌词");
        gtk_widget_show (config_label8);
        gtk_fixed_put (GTK_FIXED (fixed), config_label8, 334, 176);
        gtk_widget_set_size_request (config_label8, 148,  72);

        gtk_label_set_markup ((GtkLabel  *)config_label1, g_markup_printf_escaped ("<span  foreground='#%s'>歌词</span>",lrc_color_back));
        gtk_label_set_markup ((GtkLabel  *)config_label8, g_markup_printf_escaped ("<span  foreground='#%s'>歌词</span>",lrc_color_front));

        PangoFontDescription *font_desc = pango_font_description_from_string(font_lrc);
        gtk_widget_modify_font (config_label1, font_desc);
        gtk_widget_modify_font (config_label8, font_desc);
        pango_font_description_free (font_desc);
        aa = 8;
        bb = 0;
        cc = 35;
        fontbutton_treeview = gtk_font_button_new_with_font  ("sans 8");
        gtk_widget_show (fontbutton_treeview);
        gtk_fixed_put (GTK_FIXED (fixed), fontbutton_treeview,334, aa+cc*(bb++));
        gtk_widget_set_size_request (fontbutton_treeview, 162, 24);

        fontbutton_info1 = gtk_font_button_new_with_font  ("sans 9");
        gtk_widget_show (fontbutton_info1);
        gtk_fixed_put (GTK_FIXED (fixed), fontbutton_info1, 334, aa+cc*(bb++));
        gtk_widget_set_size_request (fontbutton_info1, 162, 24);

        fontbutton_info2 = gtk_font_button_new_with_font  ("sans 8");
        gtk_widget_show (fontbutton_info2);
        gtk_fixed_put (GTK_FIXED (fixed), fontbutton_info2,334, aa+cc*(bb++));
        gtk_widget_set_size_request (fontbutton_info2, 162, 24);

        fontbutton_info3 = gtk_font_button_new_with_font  ("sans 7");
        gtk_widget_show (fontbutton_info3);
        gtk_fixed_put (GTK_FIXED (fixed), fontbutton_info3, 334, aa+cc*(bb++));
        gtk_widget_set_size_request (fontbutton_info3, 162, 24);

        bb = bb+ 4;

        fontbutton_lrc = gtk_font_button_new_with_font  ("sans 32");
        gtk_widget_show (fontbutton_lrc);
        gtk_fixed_put (GTK_FIXED (fixed), fontbutton_lrc,334, aa+cc*(bb++)-20);
        gtk_widget_set_size_request (fontbutton_lrc, 162, 24);

        config_button_color_front = gtk_button_new_with_label ("");
        gtk_widget_show (config_button_color_front);
        gtk_fixed_put (GTK_FIXED (fixed), config_button_color_front, 334, aa+cc*(bb)-24);
        gtk_widget_set_size_request (config_button_color_front,80,26);

        config_button_color_back = gtk_button_new_with_label ("");
        gtk_widget_show (config_button_color_back);
        gtk_fixed_put (GTK_FIXED (fixed), config_button_color_back, 416, aa+cc*(bb)-24);
        gtk_widget_set_size_request (config_button_color_back, 80, 26);

        gtk_label_set_markup ((GtkLabel  *)GTK_BIN (config_button_color_front)->child, g_markup_printf_escaped ("主颜色<span  foreground='#%s'> ███</span>",lrc_color_front));
        gtk_label_set_markup ((GtkLabel  *)GTK_BIN (config_button_color_back)->child, g_markup_printf_escaped ("次颜色<span  foreground='#%s'> ███</span>",lrc_color_back));

        button = gtk_button_new ();
        gtk_widget_show (button);
        gtk_fixed_put (GTK_FIXED (fixed), button, 334, 328);
        gtk_widget_set_size_request (button, 162, 40);

        alignment1 = gtk_alignment_new (0.5, 0.5, 0, 0);
        gtk_widget_show (alignment1);
        gtk_container_add (GTK_CONTAINER (button), alignment1);

        hbox1 = gtk_hbox_new (FALSE, 2);
        gtk_widget_show (hbox1);
        gtk_container_add (GTK_CONTAINER (alignment1), hbox1);

        image1 = gtk_image_new_from_stock ("gtk-ok", GTK_ICON_SIZE_BUTTON);
        gtk_widget_show (image1);
        gtk_box_pack_start (GTK_BOX (hbox1), image1, FALSE, FALSE, 0);

        config_label6 = gtk_label_new_with_mnemonic ("确定");
        gtk_widget_show (config_label6);
        gtk_box_pack_start (GTK_BOX (hbox1), config_label6, FALSE, FALSE, 0);
        aa = 8;
        bb = 0;
        cc = 22;
        checkbutton_save_volume = gtk_check_button_new_with_mnemonic ("保存音量");
        gtk_widget_show (checkbutton_save_volume);
        gtk_fixed_put (GTK_FIXED (fixed), checkbutton_save_volume, 16, aa+cc*(bb++));
        gtk_widget_set_size_request (checkbutton_save_volume, 200, 24);
        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_volume), TRUE);

        checkbutton_show_tools = gtk_check_button_new_with_mnemonic ("显示工具条");
        gtk_widget_show (checkbutton_show_tools);
        gtk_fixed_put (GTK_FIXED (fixed), checkbutton_show_tools, 16, aa+cc*(bb++));
        gtk_widget_set_size_request (checkbutton_show_tools, 200, 24);
        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_show_tools), TRUE);

        checkbutton_save_file = gtk_check_button_new_with_mnemonic ("记录歌曲列表");
        gtk_widget_show (checkbutton_save_file);
        gtk_fixed_put (GTK_FIXED (fixed), checkbutton_save_file, 16, aa+cc*(bb++));
        gtk_widget_set_size_request (checkbutton_save_file, 200, 24);
        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_file), TRUE);

        checkbutton_save_pos_size = gtk_check_button_new_with_mnemonic ("记录大小和位置");
        gtk_widget_show (checkbutton_save_pos_size);
        gtk_fixed_put (GTK_FIXED (fixed), checkbutton_save_pos_size, 16, aa+cc*(bb++));
        gtk_widget_set_size_request (checkbutton_save_pos_size, 200,24);
        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_pos_size), TRUE);

        checkbutton_save_file_playing = gtk_check_button_new_with_mnemonic ("记录播放的歌曲");
        gtk_widget_show (checkbutton_save_file_playing);
        gtk_fixed_put (GTK_FIXED (fixed), checkbutton_save_file_playing, 16, aa+cc*(bb++));
        gtk_widget_set_size_request (checkbutton_save_file_playing, 200, 24);

        checkbutton_save_if_play = gtk_check_button_new_with_mnemonic (" 打开程序即播放");
        gtk_widget_show (checkbutton_save_if_play);
        gtk_fixed_put (GTK_FIXED (fixed), checkbutton_save_if_play, 16,aa+cc*(bb++));
        gtk_widget_set_size_request (checkbutton_save_if_play, 200,24);

        checkbutton_save_play_mode = gtk_check_button_new_with_mnemonic (" 记录播放模式");
        gtk_widget_show (checkbutton_save_play_mode);
        gtk_fixed_put (GTK_FIXED (fixed), checkbutton_save_play_mode, 16,aa+cc*(bb++));
        gtk_widget_set_size_request (checkbutton_save_play_mode, 200,24);

        checkbutton_show_notify = gtk_check_button_new_with_mnemonic ("显示 notify-OSD");
        gtk_widget_show (checkbutton_show_notify);
        gtk_fixed_put (GTK_FIXED (fixed), checkbutton_show_notify, 16,aa+cc*(bb++));
        gtk_widget_set_size_request (checkbutton_show_notify, 200,24);

        checkbutton_show_min = gtk_check_button_new_with_mnemonic ("使用自动缩起");
        gtk_widget_show (checkbutton_show_min);
        gtk_fixed_put (GTK_FIXED (fixed), checkbutton_show_min, 16,aa+cc*(bb++));
        gtk_widget_set_size_request (checkbutton_show_min, 200,24);

        checkbutton_show_lrc = gtk_check_button_new_with_mnemonic ("使用歌词");
        gtk_widget_show (checkbutton_show_lrc);
        gtk_fixed_put (GTK_FIXED (fixed), checkbutton_show_lrc, 16,aa+cc*(bb++));
        gtk_widget_set_size_request (checkbutton_show_lrc, 200,24);

        checkbutton_save_download_lrc = gtk_check_button_new_with_mnemonic ("使用歌词下载功能");
        gtk_widget_show (checkbutton_save_download_lrc);
        gtk_fixed_put (GTK_FIXED (fixed), checkbutton_save_download_lrc, 16,aa+cc*(bb++));
        gtk_widget_set_size_request (checkbutton_save_download_lrc, 200,24);

        if (save_download_lrc_path)checkbutton_save_download_lrc_path = gtk_check_button_new_with_mnemonic ("当前状态:下载歌词到歌曲所在目录");
        else checkbutton_save_download_lrc_path = gtk_check_button_new_with_mnemonic ("当前状态:下载歌词到指定目录");
        gtk_widget_show (checkbutton_save_download_lrc_path);
        gtk_fixed_put (GTK_FIXED (fixed), checkbutton_save_download_lrc_path, 16,aa+cc*(bb++));
        gtk_widget_set_size_request (checkbutton_save_download_lrc_path, 240,24);

        config_entry_download_lrc_path = gtk_file_chooser_button_new ("指定歌词下载目录", GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER);
        gtk_widget_show (config_entry_download_lrc_path);
        gtk_fixed_put (GTK_FIXED (fixed), config_entry_download_lrc_path, 36,aa+cc*(bb++));
        gtk_widget_set_size_request (config_entry_download_lrc_path, 200,24);
        if (!save_download_lrc_path&&download_lrc_path[0])
            gtk_file_chooser_set_current_folder(GTK_FILE_CHOOSER(config_entry_download_lrc_path),download_lrc_path);

        checkbutton_save_desktop_lrc_back_png = gtk_check_button_new_with_mnemonic ("桌面歌词背景(重新播放生效)");
        gtk_widget_show (checkbutton_save_desktop_lrc_back_png);
        gtk_fixed_put (GTK_FIXED (fixed), checkbutton_save_desktop_lrc_back_png, 16,aa+cc*(bb++));
        gtk_widget_set_size_request (checkbutton_save_desktop_lrc_back_png, 200,24);

        config_entry_desktop_lrc_back_png = gtk_file_chooser_button_new ("选择桌面歌词背景", GTK_FILE_CHOOSER_ACTION_OPEN);
        gtk_widget_show (config_entry_desktop_lrc_back_png);
        gtk_fixed_put (GTK_FIXED (fixed), config_entry_desktop_lrc_back_png, 36,aa+cc*(bb++));
        gtk_widget_set_size_request (config_entry_desktop_lrc_back_png, 200,24);
        if (save_desktop_lrc_back_png&&lrc_back_png[0])
            gtk_file_chooser_set_filename(GTK_FILE_CHOOSER(config_entry_desktop_lrc_back_png),lrc_back_png);
        GtkFileFilter* filter = gtk_file_filter_new();
        gtk_file_filter_set_name(filter, "png文件");
        gtk_file_filter_add_pattern(filter,"*.[Pp][Nn][Gg]");
        gtk_file_chooser_set_filter(GTK_FILE_CHOOSER(config_entry_desktop_lrc_back_png),filter);

        checkbutton_save_lrc_no_has_press_event = gtk_check_button_new_with_mnemonic ("桌面歌词鼠标穿透");
        gtk_widget_show (checkbutton_save_lrc_no_has_press_event);
        gtk_fixed_put (GTK_FIXED (fixed), checkbutton_save_lrc_no_has_press_event, 16,aa+cc*(bb++));
        gtk_widget_set_size_request (checkbutton_save_lrc_no_has_press_event, 200,24);

        button_reset = gtk_button_new ();
        gtk_widget_show (button_reset);
        gtk_fixed_put (GTK_FIXED (fixed), button_reset, 250, 335);
        gtk_widget_set_size_request (button_reset, 70, 26);
        alignment2 = gtk_alignment_new (0.5, 0.5, 0, 0);
        gtk_widget_show (alignment2);
        gtk_container_add (GTK_CONTAINER (button_reset), alignment2);

        hbox2 = gtk_hbox_new (FALSE, 2);
        gtk_widget_show (hbox2);
        gtk_container_add (GTK_CONTAINER (alignment2), hbox2);

        image2 = gtk_image_new_from_stock ("gtk-undo", GTK_ICON_SIZE_BUTTON);
        gtk_widget_show (image2);
        gtk_box_pack_start (GTK_BOX (hbox2), image2, FALSE, FALSE, 0);

        config_label7 = gtk_label_new_with_mnemonic ("默认..");
        gtk_widget_show (config_label7);
        gtk_box_pack_start (GTK_BOX (hbox2), config_label7, FALSE, FALSE, 0);

        if (save_file)  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_file), TRUE);
        else  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_file), FALSE);
        if (save_pos_size) gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_pos_size), TRUE);
        else  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_pos_size), FALSE);
        if (show_tools) gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_show_tools), TRUE);
        else gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_show_tools), FALSE);
        if (save_volume) gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_volume), TRUE);
        else gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_volume), FALSE);
        if (save_file_playing) gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_file_playing),TRUE);
        else gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_file_playing),FALSE);
        if (save_if_play) gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_if_play),TRUE);
        else gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_if_play),FALSE);
        if (save_play_mode) gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_play_mode),TRUE);
        else gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_play_mode),FALSE);
        if (show_notify) gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_show_notify),TRUE);
        else gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_show_notify),FALSE);
        if (show_min) gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_show_min),TRUE);
        else gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_show_min),FALSE);
        if (show_lrc) gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_show_lrc),TRUE);
        else gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_show_lrc),FALSE);
        if (save_lrc_no_has_press_event) gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_lrc_no_has_press_event),TRUE);
        else gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_lrc_no_has_press_event),FALSE);
        if (save_download_lrc) gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_download_lrc),TRUE);
        else gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_download_lrc),FALSE);
        if (save_download_lrc_path) {
            gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_download_lrc_path),TRUE);
            gtk_widget_set_sensitive (config_entry_download_lrc_path,FALSE);
        } else {
            gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_download_lrc_path),FALSE);
            gtk_widget_set_sensitive (config_entry_download_lrc_path,TRUE);
        }
        if (save_desktop_lrc_back_png) {
            gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_desktop_lrc_back_png),TRUE);
            gtk_widget_set_sensitive (config_entry_desktop_lrc_back_png,TRUE);
        } else {
            gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_desktop_lrc_back_png),FALSE);
            gtk_widget_set_sensitive (config_entry_desktop_lrc_back_png,FALSE);
        }

        if (font_treeview[0])gtk_font_button_set_font_name((GtkFontButton   *)fontbutton_treeview,font_treeview);
        if (font_info1[0])gtk_font_button_set_font_name((GtkFontButton   *)fontbutton_info1,font_info1);
        if (font_info2[0])gtk_font_button_set_font_name((GtkFontButton   *)fontbutton_info2,font_info2);
        if (font_info3[0])gtk_font_button_set_font_name((GtkFontButton   *)fontbutton_info3,font_info3);
        if (font_lrc[0])gtk_font_button_set_font_name((GtkFontButton   *)fontbutton_lrc,font_lrc);

        g_signal_connect ((gpointer) config_dialog, "delete_event",G_CALLBACK ( close_config_dialog),NULL);
        g_signal_connect ((gpointer) fontbutton_treeview, "font_set",G_CALLBACK (on_fontbutton_font_set),(gpointer )1);
        g_signal_connect ((gpointer) fontbutton_info1, "font_set",G_CALLBACK (on_fontbutton_font_set),(gpointer )2);
        g_signal_connect ((gpointer) fontbutton_info2, "font_set",G_CALLBACK (on_fontbutton_font_set),(gpointer )3);
        g_signal_connect ((gpointer) fontbutton_info3, "font_set",G_CALLBACK (on_fontbutton_font_set),(gpointer )4);
        g_signal_connect ((gpointer) fontbutton_lrc, "font_set",G_CALLBACK (on_fontbutton_font_set),(gpointer )5);
        g_signal_connect ((gpointer) checkbutton_save_volume, "toggled",G_CALLBACK (on_checkbutton_toggled),(gpointer )2);
        g_signal_connect ((gpointer) checkbutton_show_tools, "toggled",G_CALLBACK (on_checkbutton_toggled),(gpointer )3);
        g_signal_connect ((gpointer) checkbutton_save_file, "toggled",G_CALLBACK (on_checkbutton_toggled),(gpointer )4);
        g_signal_connect ((gpointer) checkbutton_save_pos_size, "toggled",G_CALLBACK (on_checkbutton_toggled),(gpointer )5);
        g_signal_connect ((gpointer) checkbutton_save_file_playing, "toggled",G_CALLBACK (on_checkbutton_toggled),(gpointer )6);
        g_signal_connect ((gpointer) checkbutton_save_if_play, "toggled",G_CALLBACK (on_checkbutton_toggled),(gpointer )7);
        g_signal_connect ((gpointer) checkbutton_save_play_mode, "toggled",G_CALLBACK (on_checkbutton_toggled),(gpointer )8);
        g_signal_connect ((gpointer) checkbutton_show_notify, "toggled",G_CALLBACK (on_checkbutton_toggled),(gpointer )9);
        g_signal_connect ((gpointer) checkbutton_show_min, "toggled",G_CALLBACK (on_checkbutton_toggled),(gpointer )10);
        g_signal_connect ((gpointer) checkbutton_show_lrc, "toggled",G_CALLBACK (on_checkbutton_toggled),(gpointer )11);
        g_signal_connect ((gpointer) checkbutton_save_lrc_no_has_press_event, "toggled",G_CALLBACK (on_checkbutton_toggled),(gpointer )12);
        g_signal_connect ((gpointer) checkbutton_save_download_lrc, "toggled",G_CALLBACK (on_checkbutton_toggled),(gpointer )13);
        g_signal_connect ((gpointer) checkbutton_save_download_lrc_path, "toggled",G_CALLBACK (on_checkbutton_toggled),(gpointer )14);
        g_signal_connect ((gpointer) checkbutton_save_desktop_lrc_back_png, "toggled",G_CALLBACK (on_checkbutton_toggled),(gpointer )15);

        g_signal_connect ((gpointer) config_button_color_front,"clicked" ,G_CALLBACK( get_colorselection),(gpointer )1);
        g_signal_connect ((gpointer) config_button_color_back,"clicked" ,G_CALLBACK( get_colorselection),(gpointer )2);
        g_signal_connect ((gpointer) button,"clicked" ,G_CALLBACK( close_config_dialog),config_dialog);
        g_signal_connect ((gpointer) button_reset,"clicked" ,G_CALLBACK( on_reset_button_clicked),NULL);

        show_iceplayer=TRUE;
        gtk_window_set_focus ((GtkWindow *)config_dialog,button);
        gtk_widget_show(config_dialog);
        show_config_dialog = TRUE;
    }
}
gvoid read_config() {
    gchar data[2000];
    FILE *fileconfig = fopen(config_file_path,"r");
    if (fileconfig==NULL||fgets(data,2000,fileconfig)==NULL) {
        FILE * fileconfig = fopen(config_file_path,"a+");
        fputs("#此文件为IcePlayer的配置文件，几个变量顺序不变就行,“#”开头的将忽略，空行值为0\n#是否保存播放列表，1为保存，0为不保存。\n1\n#是否保存窗口大小位置，1为保存，0为不保存。\n1\n#大小位置(width,height,x,y)\n300,480,538,172\n#是否保存正在播放的歌曲，1为保存，0为不保存。\n0\n#是否保存播放状态，1为保存，0为不保存。\n0\n#是否显示工具条，1为显示，0为不显示。\n1\n#是否保存音量，1为保存，0为不保存。\n1\n#音量\n100\n#列表框的字体和大小\nsans 8\n#“正在播放“文本框的字体和大小\nsans 9\n#“播放状态“\nsans 8\n#”播放时间“\nsans 7\n#歌词字体\nsans 32\n#是否保存选中的歌曲以便下次打开时选中？1为保存，0为不保存.\n1\n播放歌曲的序号，0为第一首\n0\n#是否打开就播放？1是，0否。\n0\n#记录播放模式？1为保存，0为不保存\n1\n#播放模式 0为顺序 1为随机 2为单曲\n1\n#显示notify? 1为显示 0为不显示\n1\n#自动缩进？1 是 0 否\n1\n#使用歌词？1 是 0否。\n1\n#歌词鼠标穿透？1 是 0否\n0\n0,0\n#歌词主颜色\nB19356\n#歌词次颜色\n000000\n#是否使用歌词下载功能?1 是 0否。\n1\n#是否将歌词下载于歌曲目录?1是 或 指定目录。\n1\n#是否使用桌面歌词背景？0否或指定png(如 /home/slax/图片/1.png )\n0\n# jasy.ice@163.com 2010 GPL\n ",fileconfig);
        save_file=save_pos_size=show_tools=save_volume=save_file_playing=save_play_mode=show_notify=show_min=show_lrc=save_download_lrc_path=save_download_lrc=TRUE;
        save_lrc_no_has_press_event=  save_if_play=save_desktop_lrc_back_png=FALSE;
        gchar filename[2000];
        strcpy(lrc_color_front,"B19356");
        strcpy(lrc_color_back,"000000");
        FILE *filelst = fopen(list_file_path,"a+");
        while (fgets(filename,2000,filelst)) {
            filename[strlen(filename)-1] = '\0';
            add_to_list(treeview,filename,0);
            if (fgets(filename,2000,filelst)) {};
        }
        fclose(fileconfig);
        gtk_tree_view_set_cursor((GtkTreeView *) treeview,(GtkTreePath *)gtk_tree_path_new_from_indices (0,-1), gtk_tree_view_get_column((GtkTreeView *) treeview,0), FALSE);
        PangoFontDescription *pfd;
        pfd = pango_font_description_from_string("sans 8");
        gtk_widget_modify_font(GTK_WIDGET(treeview),pfd);
        pango_font_description_free(pfd);
        pfd = pango_font_description_from_string("sans 9");
        gtk_widget_modify_font(GTK_WIDGET(label_info),pfd);
        pango_font_description_free(pfd);
        pfd = pango_font_description_from_string("sans 8");
        gtk_widget_modify_font(GTK_WIDGET(label_info2),pfd);
        pango_font_description_free(pfd);
        pfd = pango_font_description_from_string("sans 7");
        gtk_widget_modify_font(GTK_WIDGET(label_info3),pfd);
        pango_font_description_free(pfd);
        pfd = pango_font_description_from_string("sans 32");
        strcpy(font_lrc,"sans 32");
        if (lrc_label)gtk_widget_modify_font(GTK_WIDGET(lrc_label),pfd);
        if (lrc_label)gtk_widget_modify_font(GTK_WIDGET(lrc_label2),pfd);
        if (GTK_IS_WINDOW(lrc_window)) gtk_window_resize((GtkWindow   *)lrc_window,1,1);
        pango_font_description_free(pfd);
        gtk_window_resize ( (GtkWindow *)IcePlayer,300,480);
        gtk_window_move( (GtkWindow *)IcePlayer,538,172);
        lrc_x = 0;
        lrc_y= 0;
        return ;
    }
    fclose(fileconfig);
    fileconfig = fopen(config_file_path,"r");
    while (fgets(data,2000,fileconfig)) {
        //列表
        while (data[0] == '#') {
            if (fgets(data,2000,fileconfig)) {};
        }
        if ( data[0]=='1') {
            save_file=TRUE;
        } else {
            save_file=FALSE;
        }
        GtkListStore *store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(treeview)));
        gtk_list_store_clear(store);
        if (save_file==TRUE) {
            gchar filename[2000];
            FILE *filelst = fopen(list_file_path,"a+");
            while (fgets(filename,2000,filelst)) {
                filename[strlen(filename)-1] = '\0';
                add_to_list(treeview,filename,0);
                if (fgets(filename,2000,filelst)) {};
            }
            fclose(filelst);
        } else {
            unlink(list_file_path);
        }
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //保存位置?
        while (data[0] == '#') {
            if (fgets(data,2000,fileconfig)) {};
        }
        if (data==NULL)return;
        if ( data[0]=='1') save_pos_size=TRUE;
        else {
            save_pos_size=FALSE;
        }
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        gint width,height,x,y;
        if (fscanf(fileconfig,"%d,%d,%d,%d\n",&width,&height,&x,&y)) {};
        if (save_pos_size) {
            gtk_window_resize ( (GtkWindow *)IcePlayer,width,height);
            gtk_window_move( (GtkWindow *)IcePlayer,x,y);
        }
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //保存播放位置?
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        if ( data[0]=='1') {
            save_file_playing=TRUE;
        } else {
            save_file_playing=FALSE;
        }
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //打开既播放?
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        if ( data[0]=='1') {
            save_if_play=TRUE;
        } else {
            save_if_play=FALSE;
        }
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //显示tools？
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        if ( data[0]=='1') {
            show_tools=TRUE;
        } else {
            show_tools=FALSE;
        }
        if (show_tools) {
            gtk_widget_set_size_request(fixed_list,300,30);
            gtk_widget_show(eventbox_tools_add);
            gtk_widget_show(eventbox_tools_dele);
            gtk_widget_show(eventbox_tools_list);
            gtk_widget_show(eventbox_tools_mode);
        } else {
            gtk_widget_set_size_request(fixed_list,300,11);
            gtk_widget_hide(eventbox_tools_add);
            gtk_widget_hide(eventbox_tools_dele);
            gtk_widget_hide(eventbox_tools_list);
            gtk_widget_hide(eventbox_tools_mode);
        }
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //保存音量?
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        if ( data[0]=='1') save_volume=TRUE;
        else {
            save_volume=FALSE;
        }
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //音量
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        data[strlen(data)-1]= '\0';
        if (save_volume)volume = ((gdouble)atoi(data))/100.0;
        else volume = 1.0;
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //列表框字体
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        data[strlen(data)-1]='\0';
        strcpy(font_treeview,data);
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //正在播放字体
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        data[strlen(data)-1]='\0';
        strcpy(font_info1,data);
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //播放状态字体
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        data[strlen(data)-1]='\0';
        strcpy(font_info2,data);
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //播放时间字体
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        data[strlen(data)-1]='\0';
        strcpy(font_info3,data);
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //歌词字体
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        data[strlen(data)-1]='\0';
        strcpy(font_lrc,data);
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        data[strlen(data)-1]='\0';
        if ( data[0]=='1') {
            save_file_playing=TRUE;
        } else {
            save_file_playing=FALSE;
        }
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //歌曲序号
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        list_number =0;
        gtk_tree_model_foreach(gtk_tree_view_get_model(GTK_TREE_VIEW(treeview)), (GtkTreeModelForeachFunc)get_list_number,NULL);
        if (save_file_playing) {
            data[strlen(data)-1]='\0';
            int a= atoi(data);
            if (list_number>0) {
                if (a<list_number) {
                    gtk_tree_view_set_cursor((GtkTreeView *) treeview,(GtkTreePath *)gtk_tree_path_new_from_indices (a,-1), gtk_tree_view_get_column((GtkTreeView *) treeview,0), FALSE);
                } else {
                    gtk_tree_view_set_cursor((GtkTreeView *) treeview,(GtkTreePath *)gtk_tree_path_new_from_indices (list_number-1,-1), gtk_tree_view_get_column((GtkTreeView *) treeview,0), FALSE);
                }
            }
        } else {
            if (list_number>0) {
                gtk_tree_view_set_cursor((GtkTreeView *) treeview,(GtkTreePath *)gtk_tree_path_new_from_indices (0,-1), gtk_tree_view_get_column((GtkTreeView *) treeview,0), FALSE);
            }
        }
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        data[strlen(data)-1]='\0';
        if ( data[0]=='1') {
            save_if_play=TRUE;
        } else {
            save_if_play=FALSE;
        }
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //播放模式
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        data[strlen(data)-1]='\0';
        if ( data[0]=='1') {
            save_play_mode=TRUE;
        } else {
            save_play_mode=FALSE;
        }
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        data[strlen(data)-1]='\0';
        if (save_play_mode) {
            play_type =atoi(data);
        } else {
            play_type = 0;
        }
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //显示notify
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        data[strlen(data)-1]='\0';
        if ( data[0]=='1') {
            show_notify=TRUE;
        } else {
            show_notify=FALSE;
        }
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //自动缩放
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        data[strlen(data)-1]='\0';
        if ( data[0]=='1') {
            show_min=TRUE;
        } else {
            show_min=FALSE;
        }
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //显示歌词
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        data[strlen(data)-1]='\0';
        if ( data[0]=='1') {
            show_lrc=TRUE;
        } else {
            show_lrc=FALSE;
        }
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //鼠标穿透
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        data[strlen(data)-1]='\0';
        if ( data[0]=='1') {
            save_lrc_no_has_press_event=TRUE;
        } else {
            save_lrc_no_has_press_event=FALSE;
        }
        if (fscanf(fileconfig,"%d,%d\n",&lrc_x,&lrc_y)) {};
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //前景色
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        data[strlen(data)-1]='\0';
        if (data[0])strcpy(lrc_color_front,data);
        else  strcpy(lrc_color_front,"B19356");
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //背景色
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        data[strlen(data)-1]='\0';
        if (data[0])strcpy(lrc_color_back,data);
        else  strcpy(lrc_color_back,"000000");
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //使用歌词下载功能
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        data[strlen(data)-1]='\0';
        if (data[0]=='1')save_download_lrc=TRUE;
        if (data[0]=='0')save_download_lrc=FALSE;
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //歌词下载目录
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        data[strlen(data)-1]='\0';
        if (data[0]=='1')save_download_lrc_path=TRUE;
        else {
            save_download_lrc_path=FALSE;
            strcpy(download_lrc_path,data);
        }
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //使用桌面歌词背景
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        data[strlen(data)-1]='\0';
        if (data[0]=='0')save_desktop_lrc_back_png = FALSE;
        else {
            save_desktop_lrc_back_png = TRUE;
            strcpy(lrc_back_png,data);
        }
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }

    }
    PangoFontDescription *pfd;
    pfd = pango_font_description_from_string(font_treeview);
    gtk_widget_modify_font(GTK_WIDGET(treeview),pfd);
    pango_font_description_free(pfd);
    pfd = pango_font_description_from_string(font_info1);
    gtk_widget_modify_font(GTK_WIDGET(label_info),pfd);
    pango_font_description_free(pfd);
    pfd = pango_font_description_from_string(font_info2);
    gtk_widget_modify_font(GTK_WIDGET(label_info2),pfd);
    pango_font_description_free(pfd);
    pfd = pango_font_description_from_string(font_info3);
    gtk_widget_modify_font(GTK_WIDGET(label_info3),pfd);
    pango_font_description_free(pfd);
    pfd = pango_font_description_from_string(font_lrc);
    if (lrc_label)gtk_widget_modify_font(GTK_WIDGET(lrc_label),pfd);
    if (lrc_label)gtk_widget_modify_font(GTK_WIDGET(lrc_label2),pfd);
    if (GTK_IS_WINDOW(lrc_window)) gtk_window_resize((GtkWindow   *)lrc_window,1,1);
    pango_font_description_free(pfd);
    fclose(fileconfig);
}
gvoid save_config() {
    unlink(config_file_path);
    FILE *  fileconfig = fopen(config_file_path,"a+");
    fputs("#此文件为IcePlayer的配置文件，几个变量顺序不变就行,“#”开头的将忽略，空行值为0\n",fileconfig);
    fputs("#是否保存播放列表，1为保存，0为不保存。\n",fileconfig);
    if (save_file) {
        fputs("1\n",fileconfig);
    } else {
        fputs("0\n",fileconfig);
    }
    fputs("#是否保存窗口大小位置，1为保存，0为不保存。\n",fileconfig);
    if (save_pos_size) {
        fputs("1\n",fileconfig);
    } else {
        fputs("0\n",fileconfig);
    }
    fputs("#大小位置(width,height,x,y)\n",fileconfig);
    gint width,height,x,y;
    gchar A[40];
    gtk_window_get_size ( (GtkWindow *)IcePlayer,&width,&height);
    gtk_window_get_position( (GtkWindow *)IcePlayer,&x,&y);
    if (height!=3) {
        g_snprintf(A,40,"%d,%d,%d,%d\n",width,height,x,y);
    } else {
        g_snprintf(A,40,"%d,%d,%d,%d\n",width,height2,x,y);
    }
    fputs(A,fileconfig);
    fputs("#是否保存正在播放的歌曲，1为保存，0为不保存。\n",fileconfig);
    if (save_file_playing) {
        fputs("1\n",fileconfig);
    } else {
        fputs("0\n",fileconfig);
    }
    fputs("#是否保存播放状态，1为保存，0为不保存。\n",fileconfig);
    if (save_if_play) {
        fputs("1\n",fileconfig);
    } else {
        fputs("0\n",fileconfig);
    }
    fputs("#是否显示工具条，1为显示，0为不显示。\n",fileconfig);
    if (show_tools) {
        fputs("1\n",fileconfig);
    } else {
        fputs("0\n",fileconfig);
    }
    fputs("#是否保存音量，1为保存，0为不保存。\n",fileconfig);
    if (save_volume) {
        fputs("1\n",fileconfig);
    } else {
        fputs("0\n",fileconfig);
    }
    fputs("#音量\n",fileconfig);
    if (save_volume) {
        fprintf(fileconfig,"%f\n",volume*100.0);
    } else {
        fputs("0\n",fileconfig);
    }
    fputs("#列表框的字体和大小\n",fileconfig);
    if (font_treeview[0]) {
        fputs(font_treeview,fileconfig);
    } else {
        fputs(  "sans 8 " ,fileconfig);
    }
    fputs("\n",fileconfig);
    fputs("#“正在播放“文本框的字体和大小\n",fileconfig);
    if (font_info1[0]) {
        fputs(font_info1,fileconfig);
    } else {
        fputs( "sans 9 ",fileconfig);
    }
    fputs("\n",fileconfig);
    fputs("#“播放状态“文本框的字体和大小\n",fileconfig);
    if (font_info2[0]) {
        fputs(font_info2,fileconfig);
    } else {
        fputs( " sans 8 " ,fileconfig);
    }
    fputs("\n",fileconfig);
    fputs("#”播放时间“文本框的字体和大小\n",fileconfig);
    if (font_info3[0]) {
        fputs(font_info3,fileconfig);
    } else {
        fputs("sans 7" ,fileconfig);
    }
    fputs("\n",fileconfig);
    fputs("#歌词字体大小\n",fileconfig);
    if (font_lrc[0]) {
        fputs(font_lrc,fileconfig);
    } else {
        fputs("sans 32" ,fileconfig);
    }
    fputs("\n",fileconfig);
    fputs("#是否保存选中的歌曲以便下次打开时选中？1为保存，0为不保存.\n",fileconfig);
    if (save_file_playing) {
        fputs("1",fileconfig);
    } else {
        fputs("0",fileconfig);
    }
    fputs("\n",fileconfig);
    fputs("#播放歌曲的序号，0为第一首\n",fileconfig);
    if (play_path) {
        GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(treeview));
        gtk_tree_model_foreach(model, (GtkTreeModelForeachFunc)get_list_number,NULL);
        char b[100];
        strcpy(b,gtk_tree_path_to_string(play_path));
        int a= atoi(b);
        if (a<list_number) {
            fputs(gtk_tree_path_to_string(play_path),fileconfig);
        } else {
            g_snprintf(b,100,"%d",list_number);
            fputs(b,fileconfig);
        }
    } else {
        fputs("0",fileconfig);
    }
    fputs("\n",fileconfig);
    fputs("#是否打开就播放？1是，0否。\n",fileconfig);
    if (save_if_play) {
        fputs("1",fileconfig);
    } else {
        fputs("0",fileconfig);
    }
    fputs("\n",fileconfig);
    fputs("#记录播放模式？1为保存，0为不保存\n",fileconfig);
    if (save_play_mode) {
        fputs("1",fileconfig);
    } else {
        fputs("0",fileconfig);
    }
    fputs("\n",fileconfig);
    fputs("#播放模式 0为顺序 1为随机 2为单曲\n",fileconfig);
    fprintf(fileconfig,"%d\n",play_type);
    fputs("#显示notify? 1为显示 0为不显示\n",fileconfig);
    if (show_notify) {
        fputs("1",fileconfig);
    } else {
        fputs("0",fileconfig);
    }
    fputs("\n",fileconfig);
    fputs("#自动缩进？1 是 0 否\n",fileconfig);
    if (show_min) {
        fputs("1",fileconfig);
    } else {
        fputs("0",fileconfig);
    }
    fputs("\n",fileconfig);
    fputs("#使用歌词？1 是 0 否\n",fileconfig);
    if (show_lrc) {
        fputs("1",fileconfig);
    } else {
        fputs("0",fileconfig);
    }
    fputs("\n",fileconfig);
    fputs("#歌词鼠标穿透？1 是 0 否\n",fileconfig);
    if (save_lrc_no_has_press_event) {
        fputs("1",fileconfig);
    } else {
        fputs("0",fileconfig);
    }
    fputs("\n",fileconfig);
    fprintf(fileconfig,"%d,%d\n",lrc_x,lrc_y);
    fputs("#歌词主颜色\n",fileconfig);
    fputs(lrc_color_front,fileconfig);
    fputs("\n",fileconfig);
    fputs("#歌词次颜色\n",fileconfig);
    fputs(lrc_color_back,fileconfig);
    fputs("\n",fileconfig);

    fputs("#是否使用歌词下载功能?1 是 0否。\n",fileconfig);
    if (save_download_lrc) fputs("1",fileconfig);
    else fputs("0",fileconfig);
    fputs("\n",fileconfig);
    if (GTK_IS_FILE_CHOOSER(config_entry_download_lrc_path))strcpy(download_lrc_path,gtk_file_chooser_get_current_folder (GTK_FILE_CHOOSER(config_entry_download_lrc_path)));
    fputs("#是否将歌词下载于歌曲目录?1是 或 指定目录。\n",fileconfig);
    if (save_download_lrc_path)  fputs("1",fileconfig);
    else fputs(download_lrc_path,fileconfig);
    fputs("\n",fileconfig);
    if (GTK_IS_FILE_CHOOSER(config_entry_desktop_lrc_back_png)) {
        gchar *a= gtk_file_chooser_get_filename (GTK_FILE_CHOOSER(config_entry_desktop_lrc_back_png));
        if (a)strcpy(lrc_back_png,a);
    }
    fputs("#是否使用桌面歌词背景？0否或指定png(如 /home/slax/图片/1.png )\n",fileconfig);
    if (!save_desktop_lrc_back_png)  fputs("0",fileconfig);
    else fputs(lrc_back_png,fileconfig);
    fputs("\n",fileconfig);

    fputs("# jasy.ice@163.com 2010 GPL\n",fileconfig);
    fclose(fileconfig);
}
